<template>
    <div @dragover.prevent @drop.prevent>
        <div class="container box rounded-edge" @drop="handleFileDrop" @dragleave="fileDrag = false" @dragover="fileDrag = true" :class="{ 'box__dragover' : fileDrag }">
            <div class="box__input" v-if="!filesUploading">
                <input
                        class="box__file"
                        type="file"
                        id="files"
                        ref="files"
                        multiple
                        @change="handleFileInput()"
                />
                <label v-if="filesCount == 0" for="files"><strong>Choose a file</strong><span class="box__dragndrop"> or drag it here</span></label>

                <img class="box__icon" src="~/assets/images/upload.svg" alt="upload image">

                <input
                        class="box__file"
                        type="file"
                        id="filesFolder"
                        ref="folder"
                        @change="handleFolderInput()"
                        webkitdirectory mozdirectory multiple
                />
                <label v-if="filesCount == 0" for="filesFolder"><strong>or click here to upload a folder.</strong></label>

                <label v-if="filesCount > 0" for="files">{{ fileText }}</label>
                <div class="box_buttons" v-if="filesCount > 0 && files != []">
                    <button class="box__button remove" @click="removeFiles()">Remove</button>
                    <button class="box__button" @click="submitFiles()">Upload</button>
                </div>
            </div>
            <div class="box__uploading" v-else>
                <p>Uploading...</p>
                <span>{{ percentage }}%</span>
                <b-progress :value="percentage" variant="success" striped :animated="true"></b-progress>
                <p>Don't leave the page while uploading</p>
            </div>
            <div class="box__error" v-if="filesNotSupportedCount > 0">
                <label>There are {{ filesNotSupportedCount }} files not supported, see below which files.</label>
            </div>
        </div>
        <div class="container not-supported" v-if="filesNotSupported.length > 0">
            <h3>Not Supported files</h3>
            <p v-for="file in filesNotSupported" :key="file.name">{{ file.name }}</p>
        </div>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                files: [],
                fileDrag: false,
                filesCount: 0,
                filesNotSupportedCount: 0,
                filesNotSupported: [],
                fileText: "",
                filesUploading: false,
                TotWaitTime: 0,
                WaitTime: 0,
                timer: null,
                percentage: 0,
            }
        },
        methods: {
            handleFileDrop(event) {
                this.files = event.dataTransfer.files;

                this.showImageAmountText();
            },
            handleFileInput() {
                this.files = this.$refs.files.files;

                this.showImageAmountText();
            },
            handleFolderInput() {
                this.files = this.$refs.folder.files;

                this.showImageAmountText();
            },
            async submitFiles() {
                this.filesNotSupported = [];

                let formData = new FormData();
                for (var i = 0; i < this.files.length; i++) {
                    const fileType = this.files[i].type;

                    if (fileType === "image/png" || fileType === "image/jpg" || fileType === "image/jpeg") {
                        let file = this.files[i];
                        formData.append('image[]', file);

                    } else {
                        this.filesNotSupported.push(this.files[i]);
                        this.filesNotSupportedCount += 1;
                    }
                }

                this.filesUploading = true;
                this.calcProgressBar();
                await this.$store.dispatch("images/uploadImages", formData);
                this.filesUploading = false;
                this.resetProgressBar();
                this.removeFiles();
            },
            showImageAmountText() {
                this.fileDrag = true;

                this.filesCount = this.files.length;

                if (this.filesCount === 1) {
                    this.fileText = this.files[0].name;
                } else if (this.filesCount > 1) {
                    this.fileText = this.filesCount + " files selected";
                } else {
                    this.fileText = "";
                }
            },
            removeFiles() {
                this.files = [];
                this.filesCount = 0;
                this.fileText = "";
                this.fileDrag = false;
                this.filesNotSupportedCount = 0;
            },
            calcProgressBar() {
                const sec = Math.round(this.filesCount * 2);
                this.waitTime = sec;
                this.TotWaitTime = sec;
                this.timer = setInterval(() => this.countdown(), 1000)
            },
            countdown() {
                if(this.waitTime >= 1){
                    this.waitTime--;
                    const time = this.TotWaitTime - this.waitTime;
                    this.percentage = ((time / this.TotWaitTime)*100).toFixed(1);
                } else {
                    this.waitTime = 0;
                    clearInterval(this.timer);
                    this.timer = null;
                }
            },
            resetProgressBar(){
                this.waitTime = 0;
                this.timer = null;
                this.TotWaitTime = 0;
                this.percentage = 0;
            }
        },
    }
</script>
